#include <iostream>
#include <string>
#include "../Include/FileReader.h"
#include "../Include/FileHelper.h"
#include "../Include/NumberHelper.h"

using namespace std;

int main(int argc, char *argv[]) {
    if (argc < 2) {
        std::cerr << "Please provide a CSV formatted file.";
        return 0;
    }
    
    if (!FileHelper::FileExists(argv[1])) {
        cerr << "Filepath: " << argv[1] << " doesn't exist.";
        return 0;
    }
    
    string file = FileReader::GetFile(argv[1]);

    vector<int> rolls = NumberHelper::GetNumbers(file);
    
    
    // Calculate score
    int score = 0;
    int frame = 0;
    
    while (true) {
        if (rolls[frame] == 10) {
            if (frame + 3 == rolls.size() && rolls[frame - 3] == 10) {
                score += 10 + rolls[frame + 1] + rolls[frame + 2];
                break;
            }
        
            score += 10 + rolls[frame + 1] + rolls[frame + 2];
            frame += 1;
            continue;
        }
        
        // Spare
        if (rolls[frame] + rolls[frame + 1] == 10) {
            score += 10 + rolls[frame + 2];
            frame += 2;
            continue;
        }
        
        // Open Frame
        score += rolls[frame] + rolls[frame + 1];
        frame += 2;
        
        if (frame == rolls.size()) {
            break;
        }
    }
    
    cout << "Score: " << score << std::endl;
    
    
    return 0;
}
